import { Block, useActionPopup } from '@ensi-platform/core-components';
import { Row } from '@tanstack/react-table';
import { useRouter } from 'next/router';
import { useCallback, useMemo } from 'react';

import {
    useDeleteSeoTemplateProducts,
    useSearchSeoTemplateProducts,
    useSeoTemplateProductsMeta,
} from '@api/content/seo';
import { SeoTemplate, SeoTemplateProduct } from '@api/content/types/seo';

import { useError, useSuccess } from '@context/modal';

import LoadingSkeleton from '@controls/LoadingSkeleton';

import AutoFilters from '@components/AutoFilters';
import Table, { ExtendedRow, TooltipItem, useSorting, useTable } from '@components/Table';
import { getSelectColumn, getSettingsColumn } from '@components/Table/columns';
import { TableEmpty, TableFooter, TableHeader } from '@components/Table/components';

import { ModalMessages } from '@scripts/constants';
import { ActionType } from '@scripts/enums';
import { Button, Layout, colors, scale, typography } from '@scripts/gds';
import { declOfNum, getPagination, getTotal, getTotalPages } from '@scripts/helpers';
import { useRedirectToNotEmptyPage, useTableList } from '@scripts/hooks';
import { useAutoColumns, useAutoFilters, useAutoTableData } from '@scripts/hooks/autoTable';

import { useSeoAccess } from '../../useSeoAccess';

export const BindedProducts = ({
    canEdit,
    onAdd,
    template,
}: {
    canEdit: boolean;
    onAdd: () => void;
    template?: SeoTemplate;
}) => {
    const { push, pathname } = useRouter();

    const { access } = useSeoAccess();

    const { data: apiMeta, isFetching: isMetaLoading, error: metaError } = useSeoTemplateProductsMeta();
    const meta = apiMeta?.data;

    const {
        metaField,
        values,
        filtersActive,
        URLHelper,
        searchRequestFilter,
        emptyInitialValues,
        reset,
        clearInitialValue,
        codesToSortKeys,
    } = useAutoFilters(meta, {
        isSaveToUrl: false,
    });

    const pageKey = 'binded-product';

    const [{ backendSorting }, sortingPlugin] = useSorting<SeoTemplateProduct>(pageKey, meta?.fields);

    const { activePage, itemsPerPageCount, setItemsPerPageCount } = useTableList({
        defaultSort: meta?.default_sort,
        codesToSortKeys,
    });

    const {
        data,
        isFetching: isLoading,
        error,
        isRefetching,
    } = useSearchSeoTemplateProducts(
        {
            sort: backendSorting,
            filter: {
                template_id: template?.id,
                ...searchRequestFilter,
            },
            include: ['product'],
            pagination: getPagination(activePage, itemsPerPageCount),
        },
        !!meta && !!backendSorting && !!template && !!template?.id
    );

    const rows = useAutoTableData<SeoTemplateProduct>(data?.data, metaField);
    const autoGeneratedColumns = useAutoColumns(meta, false);

    const total = getTotal(data);
    const totalPages = getTotalPages(data, itemsPerPageCount);

    useRedirectToNotEmptyPage({ activePage, itemsPerPageCount, total });

    const unbindProducts = useDeleteSeoTemplateProducts();
    useSuccess(unbindProducts.isSuccess && ModalMessages.SUCCESS_UPDATE);
    useError(error || metaError || unbindProducts.error);

    const { popupState, popupDispatch, ActionPopup, ActionEnum } = useActionPopup();

    const renderHeader = useCallback(
        (selected: Row<SeoTemplateProduct>[], resetSelection: () => void) => (
            <TableHeader css={{ justifyItems: 'space-between' }}>
                <Layout type="flex" gap={scale(4)} align="center" css={{ width: '100%', minHeight: scale(9) }}>
                    <Layout.Item>
                        <div css={{ display: 'flex', flexDirection: 'column' }}>
                            <p css={typography('bodySm')}>
                                <b>Всего привязано:</b> {`${total} ${declOfNum(total, ['товар', 'товара', 'товаров'])}`}
                            </p>
                            {!canEdit && (
                                <small css={{ color: colors.grey600, marginTop: scale(1, true) }}>
                                    У вас нет прав привязывать и отвязывать товары
                                </small>
                            )}
                        </div>
                    </Layout.Item>
                    {!!selected.length && (
                        <>
                            <Layout.Item>
                                <b>Выбрано:</b> {selected.length}
                            </Layout.Item>
                            <Layout.Item>
                                <Button type="button" onClick={resetSelection}>
                                    Снять выделение
                                </Button>
                            </Layout.Item>
                            <Layout.Item>
                                <Button
                                    disabled={!canEdit}
                                    type="button"
                                    theme="dangerous"
                                    onClick={() => {
                                        popupDispatch({
                                            type: ActionType.Delete,
                                            payload: {
                                                title: `Вы уверены, что хотите отвязать выбранные товары?`,
                                                popupAction: ActionEnum.UNTIE,
                                                onAction: async () => {
                                                    await unbindProducts.mutateAsync({
                                                        id: template?.id!,
                                                        ids: selected.map(e => e.original.product_id) as number[],
                                                    });
                                                    resetSelection();
                                                },
                                                children: (
                                                    <p>Выбрано товаров: {selected.map(e => e?.original.id).length}</p>
                                                ),
                                            },
                                        });
                                    }}
                                >
                                    Отвязать выбранные товары
                                </Button>
                            </Layout.Item>
                        </>
                    )}
                </Layout>
                <Button onClick={onAdd} disabled={!canEdit}>
                    Добавить
                </Button>
            </TableHeader>
        ),
        [ActionEnum.UNTIE, onAdd, popupDispatch, template?.id, total, unbindProducts, canEdit]
    );

    const goToDelete = useCallback(
        (originalRows: ExtendedRow['original'][] | undefined) => {
            if (originalRows) {
                popupDispatch({
                    type: ActionType.Delete,
                    payload: {
                        title: `Вы уверены, что хотите отвязать выбранный товар?`,
                        popupAction: ActionEnum.UNTIE,
                        onAction: async () => {
                            await unbindProducts.mutateAsync({
                                id: template?.id!,
                                ids: [Number(originalRows[0].original.product_id)],
                            });
                        },
                    },
                });
            }
        },
        [ActionEnum.UNTIE, popupDispatch, template?.id, unbindProducts]
    );

    const tooltipContent: TooltipItem[] = useMemo(
        () => [
            {
                type: 'delete',
                text: 'Отвязать',
                action: goToDelete,
                isDisable: !access.ID.edit,
            },
        ],
        [goToDelete, access.ID.edit]
    );

    const columns = useMemo(
        () => [
            ...(canEdit ? [getSelectColumn(undefined, pageKey)] : []),
            ...autoGeneratedColumns,
            getSettingsColumn({
                columnsToDisable: [],
                visibleColumns: meta?.default_list,
                tooltipContent,
            }),
        ],
        [autoGeneratedColumns, meta?.default_list, canEdit]
    );

    const table = useTable(
        {
            data: rows,
            columns,
            meta: {
                tableKey: pageKey,
            },
        },
        [sortingPlugin]
    );

    return (
        <div css={{ marginTop: scale(4) }}>
            <h2 css={{ marginBottom: scale(2) }}>Привязанные товары</h2>
            <AutoFilters
                initialValues={values}
                emptyInitialValues={emptyInitialValues}
                onSubmit={URLHelper}
                filtersActive={filtersActive}
                meta={meta}
                isLoading={isMetaLoading}
                onResetFilters={reset}
                clearInitialValue={clearInitialValue}
                css={{ marginBottom: scale(2) }}
            />
            {isLoading || isRefetching ? (
                <LoadingSkeleton
                    count={10}
                    height={40}
                    css={{
                        marginBottom: scale(1),
                    }}
                />
            ) : (
                <Block>
                    <Block.Body>
                        {renderHeader(table.getSelectedRowModel().flatRows, table.reset)}
                        <Table instance={table} />

                        {rows.length === 0 && !isLoading ? (
                            <TableEmpty
                                filtersActive={filtersActive}
                                titleWithFilters="Привязанные товары не найдены. Попробуйте сбросить фильтры."
                                titleWithoutFilters="Нет привязанных товаров"
                                addItems={() => setItemsPerPageCount(10)}
                                onResetFilters={() => {
                                    reset();
                                    push({
                                        pathname,
                                        query: {
                                            entity_id: template?.id,
                                        },
                                    });
                                }}
                            />
                        ) : (
                            <TableFooter
                                pages={totalPages}
                                itemsPerPageCount={itemsPerPageCount}
                                setItemsPerPageCount={setItemsPerPageCount}
                            />
                        )}
                    </Block.Body>
                </Block>
            )}

            <ActionPopup popupState={popupState} popupDispatch={popupDispatch} />
        </div>
    );
};
